# No need for debuginfo or stripping
%global debug_package %{nil}
%global __strip /bin/true

Name:           freedom-u540-c000-bootloader
Version:        2019.08.25.128f282
Release:        6%{?dist}
Summary:        SiFive FU540 ZSBL and FSBL

License:        Apache-2.0 | GPLv2+
URL:            https://github.com/sifive/freedom-u540-c000-bootloader
# This is a full git clone copy (incl. git), --depth 1 should be enough
# This allows Makefile to extract version information from .git
Source0:        %{name}-%{version}.tar.xz

Patch0:         drop-unneeded-sectiosn-fix-string.patch

# Needed for kernel to properly install
BuildRequires:  systemd-udev
BuildRequires:  grubby-deprecated
# Needed to generate version information
BuildRequires:  git
# Needed to compile DTB ( ZSBL and FSBL)
BuildRequires:  dtc
# We depend on kernel for a new DTB
BuildRequires:  kernel-core

BuildRequires:  gcc
BuildRequires:  binutils

%description
Provides booloaders for SiFive (FU540) HiFive Unleashed board:
- Zeroth Stage Boot Loader (ZSBL)
- First Stage Boot Loader (FSBL)

%prep
%autosetup -p1

%build
# Replace old DTB in FSBL with new one from kernel (upstream)
rm -fv ./fsbl/ux00_fsbl.dts
# We only have 1 kernel installed in buildroot
cp -fv /boot/dtb-*/sifive/hifive-unleashed-a00.dtb ./fsbl/ux00_fsbl.dtb

make CROSSCOMPILE=

%install
install -d %{buildroot}/boot/freedom-u540-c000-bootloader/unstable/
install -m 755 zsbl.bin %{buildroot}/boot/freedom-u540-c000-bootloader/unstable/
install -m 755 fsbl.bin %{buildroot}/boot/freedom-u540-c000-bootloader/unstable/

%files
%license LICENSE
/boot/freedom-u540-c000-bootloader/unstable/{zsbl,fsbl}.bin

%changelog
* Wed Nov 13 2019 David Abdurachmanov <david.abdurachmanov@sifive.com> 2019.08.25.128f282-6
- Bump for new kernel

* Tue Oct 23 2019 David Abdurachmanov <david.abdurachmanov@sifive.com> 2019.08.25.128f282-5
- Bump for new kernel

* Tue Oct 22 2019 David Abdurachmanov <david.abdurachmanov@sifive.com> 2019.08.25.128f282-4
- Bump for new kernel

* Tue Sep 24 2019 David Abdurachmanov <david.abdurachmanov@sifive.com> 2019.08.25.128f282-3
- Bump for new kernel
- Ensure CFLAGS incl. -no-pie -fno-PIE

* Mon Aug 26 2019 David Abdurachmanov <david.abdurachmanov@sifive.com> 2019.08.25.128f282-2
- Update FSBL DTB from upstream kernel

* Sun Aug 25 2019 David Abdurachmanov <david.abdurachmanov@sifive.com> 2019.08.25.128f282-1
- Add initial version


